Google Web Toolkit
Search Google Code:

# Class Composite

public class Composite
extends Widget
// Superclass of `DisclosurePanel`, `SuggestBox`, `TabBar`, `TabPanel`
A type of widget that can wrap another widget, hiding the wrapped widget's methods. When added to a panel, a composite behaves exactly as if the widget it wraps had been added.

The composite is useful for creating a single widget out of an aggregate of multiple other widgets contained in a single panel.

### Example

    public class CompositeExample implements EntryPoint {

      /**
       * A composite of a TextBox and a CheckBox that optionally enables it.
       */
      private static class OptionalTextBox extends Composite implements
          ClickListener {

        private TextBox textBox = new TextBox();
        private CheckBox checkBox = new CheckBox();

        /**
         * Constructs an OptionalTextBox with the given caption on the check.
         *
         * @param caption the caption to be displayed with the check box
         */
        public OptionalTextBox(String caption) {
          // Place the check above the text box using a vertical panel.
          VerticalPanel panel = new VerticalPanel();
          panel.add(checkBox);
          panel.add(textBox);

          // Set the check box's caption, and check it by default.
          checkBox.setText(caption);
          checkBox.setChecked(true);
          checkBox.addClickListener(this);

          // All composites must call initWidget() in their constructors.
          initWidget(panel);

          // Give the overall composite a style name.
          setStyleName("example-OptionalCheckBox");
        }

        public void onClick(Widget sender) {
          if (sender == checkBox) {
            // When the check box is clicked, update the text box's enabled state.
            textBox.setEnabled(checkBox.isChecked());
          }
        }

        /**
         * Sets the caption associated with the check box.
         *
         * @param caption the check box's caption
         */
        public void setCaption(String caption) {
          // Note how we use the use composition of the contained widgets to provide
          // only the methods that we want to.
          checkBox.setText(caption);
        }

        /**
         * Gets the caption associated with the check box.
         *
         * @return the check box's caption
         */
        public String getCaption() {
          return checkBox.getText();
        }
      }

      public void onModuleLoad() {
        // Create an optional text box and add it to the root panel.
        OptionalTextBox otb = new OptionalTextBox("Check this to enable me");
        RootPanel.get().add(otb);
      }
    }

## Methods

getElement() | This override checks to ensure initWidget(Widget) has been called.
getWidget() | Provides subclasses access to the topmost widget that defines this composite.
initWidget(Widget) | Sets the widget to be wrapped by the composite.
isAttached() | Determines whether this widget is currently attached to the browser's document (i.e., there is an unbroken chain of widgets between this widget and the underlying browser document).
onAttach() | This method is called when a widget is attached to the browser's document.
onDetach() | This method is called when a widget is detached from the browser's document.
setWidget(Widget) | This method was for initializing the Widget to be wrapped by this Composite, but has been deprecated in favor of initWidget(Widget).

## Method Detail

### getElement

public Element getElement()
This override checks to ensure initWidget(Widget) has been called.

### getWidget

protected Widget getWidget()
Provides subclasses access to the topmost widget that defines this composite.

#### Return Value

the widget

### initWidget

protected void initWidget(Widget widget)
Sets the widget to be wrapped by the composite. The wrapped widget must be set before calling any Widget methods on this object, or adding it to a panel. This method may only be called once for a given composite.

#### Parameters

widget
  the widget to be wrapped

### isAttached

public boolean isAttached()
Determines whether this widget is currently attached to the browser's document (i.e., there is an unbroken chain of widgets between this widget and the underlying browser document).

#### Return Value

`true` if the widget is attached

### onAttach

protected void onAttach()
This method is called when a widget is attached to the browser's document. To receive notification after a Widget has been added to the document, override the onLoad method.

Subclasses that override this method must call `super.onAttach()` to ensure that the Widget has been attached to its underlying Element.

### onDetach

protected void onDetach()
This method is called when a widget is detached from the browser's document. To receive notification before a Widget is removed from the document, override the onUnload method.

Subclasses that override this method must call `super.onDetach()` to ensure that the Widget has been detached from the underlying Element. Failure to do so will result in application memory leaks due to circular references between DOM Elements and JavaScript objects.

### setWidget

protected void setWidget(Widget widget)
This method was for initializing the Widget to be wrapped by this Composite, but has been deprecated in favor of initWidget(Widget).

#### Parameters

widget